;  **********************************
;  ***  BETRIEBSSYSTEM F]R KC 87  ***
;  ***  VERSION 3.0 , TEIL 1      ***
;  ***  DIRK AMBRAS , 01.07.1988  ***
;  **********************************
;
	ORG	07100H
CAOS:	JP	START
	DEFM	'#       '
	DEFB	0
BSST:	EQU	CAOS-00100H
JPM:	EQU	BSST+000FFH
AME:	EQU	BSST
HLM:	EQU	AME+1
DEM:	EQU	AME+3
BCM:	EQU	AME+5
MEMA:	EQU	AME+16
MEMHL:	EQU	AME+17
MEMDE:	EQU	AME+19
MESC:	EQU	AME+21
SPM:	EQU	AME+22
SCUR:	EQU	AME+24
FMHL:	EQU	AME+26
FLAG:	EQU	AME+30
FFLAG:	EQU	AME+31
KEYTA:	EQU	AME+33
COL:	EQU	00027H
CCOL:	EQU	00034H
MCUR:	EQU	0003FH
;
;   VERBINDUNGEN ZUM 2.TEIL
;
SWIT:	EQU	CAOS+00AA4H
KEY:	EQU	CAOS+00AF1H
SAVE:	EQU	CAOS+00B86H
VERIF:	EQU	CAOS+00C3BH
LOAD:	EQU	CAOS+00C3FH
;
;
	JP	SWIT
	DEFM	'SWITCH  '
	DEFB	0
	JP	JUMP
	DEFM	'JUMP    '
	DEFB	0
	JP	MENU
	DEFM	'MENU    '
	DEFB	0
	JP	SAVE
	DEFM	'SAVE    '
	DEFB	0
	JP	VERIF
	DEFM	'VERIFY  '
	DEFB	0
	JP	LOAD
	DEFM	'LOAD    '
	DEFB	0
	JP	COLOR
	DEFM	'COLOR   '
	DEFB	0
	JP	MODIF
	DEFM	'MODIFY  '
	DEFB	0
	JP	DISP
	DEFM	'DISPLAY '
	DEFB	0
	JP	KEY
	DEFM	'KEY     '
	DEFB	0
	JP	KEYLI
	DEFM	'KEYLIST '
	DEFB	0
	JP	UPIN
	DEFM	'in      '
	DEFB	0
	JP	UPOUT
	DEFM	'out     '
	DEFB	0
	JP	WRITE
	DEFM	'write   '
	DEFB	0
	JP	TIME
	DEFM	'time    '
	DEFB	0
	JP	VCOL
	DEFM	'vcolor  '
	DEFB	0
	JP	LDIR
	DEFM	'ldir    '
	DEFB	0
	JP	GOTO
	DEFM	'go      '
	DEFW	0
;
TEXTM:	DEFM	'*  KC-CAOS '
	DEFM	'3.0  *'
CRL:	DEFB	10
	DEFB	13
	DEFB	'%'
	DEFB	0
RESET:	DEFM	' (C) 89 D. '
	DEFM	'Ambras, BSG '
	DEFM	'Informatik '
	DEFM	'HA-NEU'
CRL2:	DEFW	00D0AH
	DEFB	0
;
START:	LD	HL,JPM
	LD	A,(HL)
	CP	0BBH
	JP	Z,0F089H
	LD	SP,001FEH
	LD	(SPM),SP
	CALL	COPYR
	CP	0EEH
	JR	Z,WST
	LD	HL,BSST
	PUSH	HL
	POP	DE
	INC	DE
	LD	(HL),0
	LD	BC,255
	LDIR
	LD	DE,KEYTA
	LD	HL,MKEY
	LD	BC,92
	LDIR
	LD	A,0F9H
	LD	(SCUR),A
WST:	LD	A,046H
	LD	(COL),A
	LD	A,030H
	LD	(0EFC8H),A
	LD	A,020H
	LD	(MCUR),A
	LD	A,010H
	OUT	(088H),A
	CALL	CLS
	LD	DE,RESET
	CALL	PRNST
	LD	A,0
	LD	(MESC),A
	JR	MENU2
MENU:	LD	SP,001FEH
	LD	(SPM),SP
	CALL	COPYR
	CALL	CLS
MENU2:	LD	DE,TEXTM
	CALL	PRNST
	LD	A,0EEH
	LD	(JPM),A
SUCH:	LD	H,0C0H
	LD	D,0F0H
	CALL	SUCH2
	LD	HL,CAOS
	LD	DE,RESET
	CALL	SUCH2
	LD	H,2
	LD	DE,CAOS
	DEC	D
	DEC	D
	CALL	SUCH2
	LD	HL,LOAD
	LD	D,0BFH
	CALL	SUCH2
	JP	INPUT
SUCH2:	LD	L,0
SUCH3:	PUSH	HL
SUCH4:	LD	A,(HL)
	CP	0C3H
	JR	NZ,SUCH6
	INC	HL
	INC	HL
	INC	HL
	PUSH	HL
	LD	A,(HL)
	CP	'#'
	JR	Z,SUCH5
	CP	028H
	JR	C,FO02
	CP	'\'
	JR	NC,FO02
	PUSH	DE
	LD	D,H
	LD	E,L
	CALL	PRNST
	POP	DE
SUCH5:	POP	HL
	PUSH	DE
	LD	DE,9
	ADD	HL,DE
	LD	DE,CRL
	CALL	PRNST
	POP	DE
	JR	SUCH4
SUCH6:	POP	HL
	LD	A,H
	INC	H
	CP	D
	JR	NZ,SUCH2
	RET
FO02:	POP	HL
	PUSH	DE
	LD	DE,9
	ADD	HL,DE
	POP	DE
	JR	SUCH4
LDIR:	LDIR
	RET
GOTO:	JP	(HL)
CLS:	LD	A,(0003BH)
	LD	D,A
CLS3:	LD	A,(0003CH)
	SUB	D
	DEC	A
	LD	B,A
	CALL	CLS1
CLS2:	INC	D
	PUSH	DE
	PUSH	BC
	LD	(0002BH),DE
	CALL	CLLN
	POP	BC
	POP	DE
	DJNZ	CLS2
CLS1:	LD	A,(0003BH)
	INC	A
	PUSH	DE
	PUSH	BC
	LD	D,A
	LD	A,(0003DH)
	INC	A
	LD	E,A
	LD	C,18
	CALL	0F314H
	POP	BC
	POP	DE
	LD	A,020H
	LD	(MCUR),A
	RET
DRUCK:	PUSH	AF
	LD	A,E
	CP	32
	JR	NC,DRBS
	PUSH	BC
	LD	C,2
	CALL	VKEY
	POP	BC
	POP	AF
	RET
DRBS:	PUSH	HL
	PUSH	DE
	PUSH	AF
	LD	A,E
	CALL	GETHL
	LD	(HL),A
	LD	A,(COL)
	SET	3,A
	LD	(CCOL),A
	LD	E,9
	CALL	DRUCK
	POP	AF
	POP	DE
	POP	HL
	POP	AF
	RET
PRNST:	LD	A,(DE)
	OR	A
	RET	Z
	PUSH	DE
	LD	E,A
	CALL	DRUCK
	POP	DE
	INC	DE
	JR	PRNST
INPUT:	XOR	A
	LD	(FLAG),A
	CALL	INLIN
	JR	ENT
INLIN:	CALL	COPYR
	LD	C,1
	CALL	5
	JR	INL2
RESC:	CALL	GETCU
	LD	(MEMDE),BC
	LD	A,(MCUR)
	LD	(BC),A
	RET
INL2:	LD	E,A
	PUSH	AF
	CALL	DRUCK
	CP	4
	JR	NZ,NO4
	LD	A,(FFLAG)
	AND	A
	JR	Z,NO4
	POP	AF
	LD	E,2
	CALL	DRUCK
	LD	A,2
	RET
NO4:	POP	AF
	CP	13
	JR	Z,IN1
	CP	3
	JR	Z,IN1
	JR	INLIN
IN1:	LD	E,10
	CALL	DRUCK
	LD	E,11
	CALL	DRUCK
	CALL	GETCU
	PUSH	BC
	LD	E,10
	CALL	DRUCK
	POP	DE
	RET
SETC:	LD	A,030H
	LD	(0EFC8H),A
	CALL	GETCU
	LD	A,(BC)
	LD	(MCUR),A
	LD	A,(SCUR)
	CP	020H
	RET	C
	LD	(BC),A
	LD	HL,0FC00H
	ADD	HL,BC
	LD	A,(CCOL)
	LD	(HL),A
	RET
ENT:	CP	3
	JR	NZ,NO3
	LD	E,13
	CALL	DRUCK
	JP	RET
NO3:	INC	DE
	LD	A,(DE)
	CP	021H
	JP	C,RET
	LD	HL,CAOS
	LD	B,0F0H
	CALL	PSUCH
	JR	C,PROG
	LD	H,2
	LD	BC,CAOS
	DEC	B
	DEC	B
	CALL	PSUCH
	JR	C,PROG
	LD	E,'F'
	CALL	DRUCK
	JP	ERROR
PROG:	INC	DE
	PUSH	HL
	LD	A,(DE)
	CP	021H
	JR	C,NPARA
	DEC	DE
	JR	PARA
NPARA:	LD	A,0
	LD	(AME),A
	JP	GPARA
PARA:	LD	A,0
	LD	(AME),A
	PUSH	DE
	LD	DE,HLM
	LD	(MEMDE),DE
	POP	DE
	INC	DE
PARA1:	CALL	RHEX
	JR	NC,PARA2
	LD	E,'P'
	CALL	DRUCK
	JP	ERROR
PARA2:	PUSH	DE
	LD	HL,(MEMDE)
	LD	DE,(MEMHL)
	LD	(HL),E
	INC	HL
	LD	(HL),D
	INC	HL
	LD	(MEMDE),HL
	LD	A,(AME)
	INC	A
	CP	11
	LD	(AME),A
	POP	DE
	JP	NC,GPARA
	INC	DE
	LD	A,(DE)
	CP	020H
	JR	NZ,PARA1
	JR	GPARA
RHEX:	LD	HL,0
	LD	(MEMHL),HL
	XOR	A
	LD	HL,MEMA
	LD	(HL),A
RHEX1:	LD	A,(DE)
	CP	021H
	JR	C,NOTC
	JR	RHEX2
NOTC:	SCF
	CCF
	NOP
	NOP
	NOP
	RET
RHEX2:	SUB	030H
	RET	C
	CP	10
	JR	C,RH3
	SUB	7
	CP	10
	RET	C
	CP	16
	JR	C,RH3
	SCF
	RET
RH3:	INC	DE
	INC	(HL)
	INC	HL
	RLD
	INC	HL
	RLD
	DEC	HL
	DEC	HL
	JR	Z,RHEX1
	DEC	DE
	SCF
	RET
GPARA:	POP	HL
	LD	DE,RET
	PUSH	DE
	PUSH	HL
	LD	HL,(HLM)
	LD	DE,(DEM)
	LD	BC,(BCM)
	LD	A,(AME)
GJP:	RET
RET:	LD	SP,001FEH
	LD	(SPM),SP
	LD	E,'%'
	CALL	DRUCK
	CALL	COPYR
	JP	INPUT
PSUCH:	INC	B
	PUSH	DE
	LD	(MEMDE),DE
PSV:	LD	L,0
PS1:	PUSH	HL
PS2:	LD	A,(HL)
	CP	0C3H
	JR	NZ,PS4
	INC	HL
	INC	HL
	INC	HL
	PUSH	HL
	PUSH	DE
	PUSH	BC
	LD	DE,(MEMDE)
PSF:	LD	A,(DE)
	CP	021H
	JR	C,FOU
	CP	(HL)
	JR	NZ,NFOU
	INC	HL
	INC	DE
	JR	PSF
NFOU:	POP	BC
	POP	DE
	POP	HL
	PUSH	DE
	LD	DE,9
	ADD	HL,DE
	POP	DE
	LD	DE,(MEMDE)
	JR	PS2
PS4:	POP	HL
	INC	H
	LD	A,H
	CP	B
	JR	C,PSV
	SCF
	CCF
	POP	DE
	LD	DE,(MEMDE)
	RET
FOU:	POP	BC
	POP	BC
	POP	HL
	DEC	HL
	LD	B,(HL)
	DEC	HL
	LD	C,(HL)
	PUSH	BC
	POP	HL
	POP	BC
	POP	BC
	SCF
	RET
ERRM:	DEFM	' ERROR'
	DEFW	00A0DH
	DEFW	00007H
ERROR:	CALL	ERR1
	JR	RET
ERR1:	PUSH	DE
	LD	DE,ERRM
	CALL	PRNST
	POP	DE
CAOSE:	RET
JUMP:	LD	A,0BBH
	LD	(JPM),A
	LD	HL,0F314H
	LD	(6),HL
	JP	0F089H
COLOR:	LD	A,L
	DEC	A
	SLA	A
	SLA	A
	SLA	A
	SLA	A
	PUSH	AF
	LD	A,E
	POP	BC
	DEC	A
	OR	B
	LD	(COL),A
	RET
AHEX:	PUSH	AF
	PUSH	AF
	RRA
	RRA
	RRA
	RRA
	CALL	AHEX2
	POP	AF
	CALL	AHEX2
	POP	AF
	RET
AHEX2:	AND	00FH
	ADD	030H
	CP	03AH
	JR	C,ADR
	ADD	007H
ADR:	PUSH	DE
	LD	E,A
	CALL	DRUCK
	POP	DE
	RET
HLHEX:	PUSH	AF
	PUSH	DE
	LD	A,H
	CALL	AHEX
	LD	A,L
	CALL	AHEX
	LD	E,020H
	CALL	DRUCK
	POP	DE
	POP	AF
	RET
MTEXT:	DEFB	020H
	DEFW	00808H
	DEFW	00008H
MODIF:	CALL	HLHEX
	LD	(HLM),HL
	LD	A,0
	LD	(AME),A
	LD	A,(HL)
	CALL	AHEX
	LD	DE,MTEXT
	CALL	PRNST
	CALL	INLIN
	CALL	RHEX
	JR	NC,RIG1
MERR:	CALL	ERR1
	LD	HL,(HLM)
	JR	MODIF
RIG1:	LD	A,(HL)
	JR	Z,MERR
	LD	HL,MEMHL
	PUSH	DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	DE,HL
	POP	DE
	LD	B,0
MSUCH:	PUSH	HL
	INC	DE
	CALL	RHEX
	LD	A,(HL)
	OR	A
	JR	Z,EZ1
	INC	HL
	LD	A,(HL)
	POP	HL
MSET:	LD	(HL),A
	INC	B
	INC	HL
	LD	A,0
	LD	(AME),A
	PUSH	HL
EZ1:	POP	HL
	LD	A,(DE)
	CP	'.'
	RET	Z
	CP	','
	JR	NZ,EZ2
	INC	DE
	LD	A,(DE)
	INC	DE
	JR	MSET
EZ2:	LD	A,B
	OR	A
	JR	NZ,EZ3
	INC	HL
EZ3:	LD	A,(DE)
	CP	':'
	JR	NZ,EZ4
	DEC	HL
	DEC	HL
	JR	MODIF
EZ4:	CP	'/'
	JR	NZ,EZ5
	INC	DE
	CALL	RHEX
	JR	C,MERR
	LD	HL,(MEMHL)
	JR	MODIF
EZ5:	CP	020H
	JR	NZ,MERR
	LD	A,(AME)
	INC	A
	LD	(AME),A
	CP	2
	JR	C,MSUCH
	JP	MODIF
DISP:	CP	3
	JR	NC,SWJ
	LD	C,8
SWJ:	PUSH	BC
DISP2:	CALL	HLHEX
	PUSH	HL
	LD	B,8
DIS2:	LD	A,(HL)
	CALL	AHEX
	DEC	B
	JR	Z,BEDZ
	PUSH	DE
	LD	E,020H
	CALL	DRUCK
	POP	DE
	INC	HL
	JR	DIS2
BEDZ:	PUSH	DE
	LD	E,32
	CALL	DRUCK
	LD	E,32
	CALL	DRUCK
	POP	DE
	POP	HL
	LD	B,8
DZE1:	PUSH	DE
	LD	E,(HL)
	LD	A,E
	CP	020H
	JR	NC,DZE2
	LD	E,0F8H
DZE2:	CALL	DRUCK
	POP	DE
	INC	HL
	DJNZ	DZE1
	PUSH	DE
	LD	DE,CRL2
	CALL	PRNST
	POP	DE
	PUSH	DE
	EX	DE,HL
	SBC	HL,DE
	EX	DE,HL
	POP	DE
	JR	C,DIEND
	DEC	C
	JR	NZ,DISP2
	PUSH	BC
	LD	C,1
	CALL	5
	POP	BC
	CP	3
	POP	BC
	RET	Z
	CP	01DH
	JR	NZ,SWJ
	JP	MODIF
DIEND:	POP	BC
	RET
ESC:	LD	HL,FMHL
	DEC	HL
	LD	(HL),0
COPYR:	LD	HL,VKEY
	LD	(6),HL
	RET
VKEY:	LD	(MEMA),A
	LD	A,C
	CP	2
	JR	Z,DRKEY
	CP	1
	JR	Z,FTAST
	CP	022H
	JP	NC,VERW
VMON:	LD	A,(MEMA)
	JP	0F314H
DRBAS:	LD	A,(0002BH)
	LD	D,A
	LD	A,(0003DH)
	INC	A
	SUB	D
	OR	A
	JP	Z,NKEY
	JP	NKEY2
DRKEY:	LD	A,(COL)
	SET	3,A
	LD	(COL),A
	LD	A,(MEMA)
	PUSH	HL
	PUSH	BC
	PUSH	DE
	LD	A,E
	CP	020H
	JP	C,STCOD
	CP	'>'
	JR	Z,DRBAS
	JR	NKEY2
FTAST:	LD	A,(MEMA)
	PUSH	HL
	PUSH	BC
	PUSH	DE
	LD	HL,FMHL
	DEC	HL
	LD	A,(HL)
	AND	A
	JP	NZ,FEND
	CALL	SETC
	POP	DE
	POP	BC
	POP	HL
	PUSH	HL
	PUSH	BC
	PUSH	DE
	CALL	0F314H
	PUSH	AF
	CALL	RESC
	LD	A,(FLAG)
	AND	A
	JR	Z,BNO
	LD	A,(FFLAG)
	AND	A
	JR	NZ,BNO
BJA:	LD	A,1
	LD	(FFLAG),A
	POP	AF
	CP	13
	JR	NZ,NO13
	LD	E,10
	CALL	DRUCK
	JP	BASET
NO13:	LD	E,A
	CALL	DRUCK
	CALL	INLIN
	JP	BASET
BNO:	LD	HL,NRKEY
	POP	AF
	PUSH	HL
	POP	DE
	LD	BC,10
	CPIR
	JP	Z,FKEY
	JR	NKEY
NKEY2:	POP	DE
	PUSH	DE
	LD	C,2
	CALL	0F314H
NKEY:	POP	DE
	POP	BC
	POP	HL
	RET
STDR:	LD	E,A
	LD	A,(0003CH)
	DEC	A
	LD	B,A
	LD	A,(0002CH)
	SUB	B
	JR	Z,SCUP
	JR	NKEY2
SCUPT:	CALL	GETHL
	LD	A,(CCOL)
	LD	DE,0FC00H
	ADD	HL,DE
	LD	(HL),A
	LD	HL,0E828H
	LD	DE,0E800H
	LD	BC,920
	PUSH	BC
	LDIR
	LD	HL,0EC28H
	LD	DE,0EC00H
	POP	BC
	LDIR
	CALL	CLLN
	XOR	A
	JP	NKEY
SCUP:	LD	A,(0003BH)
	CP	0
	JR	NZ,SCUPN
	LD	A,(0003CH)
	CP	25
	JR	NZ,SCUPN
	LD	A,(0003DH)
	CP	0
	JP	NZ,SCUPN
	LD	A,(0003EH)
	CP	41
	JR	Z,SCUPT
SCUPN:	LD	C,2
	CALL	0F314H
	CALL	CLLN
	JP	NKEY
GETCU:	PUSH	HL
	CALL	GETHL
	PUSH	HL
	POP	BC
	POP	HL
	RET
GETHL:	PUSH	BC
	PUSH	AF
	LD	DE,40
	LD	HL,0EC00H
	LD	A,(0002CH)
	LD	B,A
GETZ:	ADD	HL,DE
	DJNZ	GETZ
	SBC	HL,DE
	LD	A,(0002BH)
	DEC	A
	LD	E,A
	ADD	HL,DE
	LD	DE,(0002BH)
	POP	AF
	POP	BC
	RET
BASET:	PUSH	AF
	XOR	A
	LD	(FFLAG),A
	LD	A,(0003DH)
	INC	A
	LD	(0002BH),A
	LD	E,11
	LD	C,2
	CALL	0F314H
	LD	DE,00362H
	LD	B,046H
	PUSH	DE
LDBAS:	CALL	GETHL
	POP	DE
	LD	A,(HL)
	CP	020H
	CALL	Z,ZLEER
	LD	(DE),A
	CP	0
	JR	Z,LDBE
	INC	DE
	LD	C,2
	PUSH	DE
	LD	E,9
	PUSH	BC
	CALL	0F314H
	POP	BC
	DJNZ	LDBAS
	POP	DE
LDBE:	LD	A,(0003DH)
	INC	A
	LD	(0002BH),A
	INC	B
	INC	B
	INC	B
	XOR	A
LDB0:	LD	(DE),A
	INC	DE
	DJNZ	LDB0
	POP	AF
	JP	NKEY
ZLEER:	LD	A,(CCOL)
	BIT	3,A
	JR	NZ,ZL1
ZL0:	XOR	A
	RET
ZL1:	LD	A,020H
	RET
TFLAG:	LD	A,(00338H)
	CP	0D6H
	JP	NZ,NKEY
	LD	A,(FLAG)
	XOR	1
	LD	(FLAG),A
	JP	NKEY
FEND:	LD	HL,(FMHL)
	INC	HL
KEYF:	LD	(FMHL),HL
	LD	A,(HL)
	OR	A
	CALL	Z,ESCC
	LD	A,(HL)
	LD	HL,FMHL
	DEC	HL
	LD	(HL),A
	JP	NKEY
EESC:	CALL	ESCC
	JP	NKEY2
ESCC:	LD	A,(MESC)
	XOR	020H
	LD	(MESC),A
	XOR	A
	RET
FKEY:	PUSH	AF
	LD	A,(MESC)
	CP	0
	JR	NZ,ME1
ME0:	POP	AF
	JP	NKEY
ME1:	POP	AF
	XOR	A
	SBC	HL,DE
	EX	DE,HL
	LD	HL,KEYTA
	LD	BC,00100H
CPIR:	DEC	E
	JR	Z,KEYF
	CPIR
	JR	CPIR
NRKEY:	DEFM	'0'
	DEFM	'1'
	DEFM	'2'
	DEFM	'3'
	DEFM	'4'
	DEFM	'5'
	DEFM	'6'
	DEFM	'7'
	DEFM	'8'
	DEFM	'9'
MKEY:	DEFB	2
	DEFM	'%B'
	DEFB	13
	DEFM	'28600'
	DEFW	13
	DEFM	'GOSUB'
	DEFB	0
	DEFM	'PRINTAT('
	DEFB	0
	DEFM	'RETURN'
	DEFB	0
	DEFM	'WINDOW'
	DEFB	0
	DEFM	'EDIT'
	DEFB	0
	DEFM	'AUTO'
	DEFB	0
	DEFM	'INK5:PAP'
	DEFM	'ER7:BORD'
	DEFM	'ER3'
	DEFW	13
	DEFM	'WINDOW:'
	DEFM	'CLS'
	DEFW	13
	DEFB	2
	DEFM	'%t'
	DEFB	13
	DEFB	11
	DEFB	11
	DEFB	01BH
	DEFW	0
KEYLI:	LD	B,0
	LD	DE,KEYTA
KL2:	PUSH	DE
	LD	DE,KEYM1
	CALL	PRNST
	LD	A,B
	CALL	AHEX2
	LD	DE,KEYM2
	CALL	PRNST
	POP	DE
	CALL	PRKEY
	LD	DE,(MEMDE)
	INC	DE
	INC	B
	PUSH	DE
	LD	DE,CRL2
	CALL	PRNST
	POP	DE
	LD	A,B
	CP	00AH
	JR	C,KL2
	RET
KEYM1:	DEFM	'KEY '
	DEFB	0
KEYM2:	DEFM	' : '
	DEFB	0
PRKEY:	PUSH	AF
	PUSH	DE
PRK1:	LD	A,(DE)
	CP	0
	JR	Z,PRK3
	PUSH	DE
	CP	020H
	JR	NC,PRK2
	LD	A,0FFH
PRK2:	LD	E,A
	CALL	DRUCK
	POP	DE
	INC	DE
	JR	PRK1
PRK3:	LD	(MEMDE),DE
	POP	DE
	POP	AF
	RET
STCOD:	CP	00AH
	JP	Z,STDR
	CP	01BH
	JP	Z,EESC
	CP	01DH
	JR	Z,ST01
	CP	00CH
	JR	Z,ST0C
	CP	01AH
	JP	Z,ST1A
	CP	019H
	JP	Z,ST19
	CP	018H
	JP	Z,ST18
	CP	002H
	JR	Z,ST02
	CP	01FH
	JP	Z,ST1F
	CP	004H
	JP	Z,TFLAG
STE0:	JP	NKEY2
STE1:	JP	NKEY
MST01:	DEFW	02008H
	DEFW	00008H
ST01:	LD	DE,MST01
	CALL	PRNST
	JR	STE1
ST0C:	CALL	CLS
	JR	STE1
ST02:	CALL	CLLN
	JR	STE1
CLLN:	LD	A,(0003DH)
	INC	A
	LD	(0002BH),A
	LD	A,(0003DH)
	LD	B,A
	LD	A,(0003EH)
	SUB	B
	DEC	A
	LD	B,A
CLL1:	CALL	GETHL
	PUSH	HL
	LD	DE,0FC00H
	ADD	HL,DE
	PUSH	HL
	POP	DE
	POP	HL
CLL2:	LD	A,(COL)
	RES	3,A
	LD	(DE),A
	LD	(CCOL),A
	LD	A,32
	LD	(HL),A
	LD	(MCUR),A
	INC	HL
	INC	DE
	DJNZ	CLL2
	RET
ST0A:	PUSH	AF
	LD	A,(0003CH)
	LD	B,A
	LD	A,(0002CH)
	CP	B
	JR	C,ESTC
	LD	C,2
	LD	E,00AH
	CALL	0F314H
	CALL	CLLN
ESTC:	POP	AF
	RET
ST0B:	PUSH	AF
	LD	A,(0003BH)
	LD	B,A
	LD	A,(0002CH)
	CP	B
	JR	NC,ESTC
	LD	C,2
	LD	E,00BH
	CALL	0F314H
	CALL	CLLN
	JR	ESTC
ST18:	LD	A,(0003EH)
	DEC	A
	LD	(0002BH),A
	JP	STE1
ST19:	LD	A,(0003DH)
	INC	A
	LD	(0002BH),A
	JP	STE1
ST1A:	CALL	GETHL
	LD	A,(0003EH)
	DEC	A
	LD	B,A
	LD	A,40
	SUB	B
	LD	B,A
	LD	A,40
	SUB	B
	SUB	E
	PUSH	AF
	LD	B,A
	LD	A,(HL)
	LD	(HL),32
ST1A1:	INC	HL
	LD	E,(HL)
	LD	(HL),A
	LD	A,E
	DJNZ	ST1A1
	CALL	GETCU
	POP	AF
	LD	HL,0FC00H
	ADD	HL,BC
	LD	B,A
	LD	C,(HL)
	LD	A,(COL)
	SET	3,A
	LD	(HL),A
	LD	A,C
ST1A2:	INC	HL
	LD	E,(HL)
	LD	(HL),A
	LD	A,E
	DJNZ	ST1A2
	XOR	A
	JP	STE1
ST1F:	CALL	GETCU
	LD	A,(0003EH)
	DEC	A
	LD	H,A
	LD	A,40
	SUB	H
	LD	H,A
	LD	A,40
	SUB	H
	SUB	E
	PUSH	AF
	LD	E,A
	PUSH	DE
	EX	DE,HL
	LD	H,0
	ADD	HL,BC
	EX	DE,HL
	LD	(MEMDE),DE
	POP	DE
	PUSH	BC
	POP	HL
	LD	D,0
	PUSH	DE
	POP	BC
	PUSH	HL
	POP	DE
	INC	HL
	LDIR
	LD	HL,(MEMDE)
	LD	(HL),32
	CALL	GETCU
	LD	HL,0FC00H
	ADD	HL,BC
	PUSH	HL
	INC	HL
	LD	A,(HL)
	LD	(CCOL),A
	DEC	HL
	POP	BC
	POP	AF
	LD	E,A
	PUSH	DE
	EX	DE,HL
	LD	H,0
	ADD	HL,BC
	EX	DE,HL
	LD	(MEMDE),DE
	POP	DE
	PUSH	BC
	POP	HL
	LD	D,0
	PUSH	DE
	POP	BC
	PUSH	HL
	POP	DE
	INC	HL
	LDIR
	LD	HL,(MEMDE)
	LD	A,(COL)
	RES	3,A
	LD	(HL),A
	JP	STE1
UPIN:	LD	C,L
	IN	A,(C)
	CALL	AHEX
	CALL	CRNL
	RET
UPOUT:	LD	C,L
	LD	A,E
	OUT	(C),A
	RET
TIME:	OR	A
	JR	NZ,STIME
GTIME:	LD	A,(0001DH)
	CALL	DRDEZ
	LD	E,':'
	CALL	DRUCK
	LD	A,(0001EH)
	CALL	DRDEZ
	LD	E,':'
	CALL	DRUCK
	LD	A,(0001FH)
	CALL	DRDEZ
CRNL:	PUSH	DE
	LD	DE,CRL2
	CALL	PRNST
	POP	DE
	RET
DEHE:	CP	060H
	JR	C,MSJ
MSN:	XOR	A
	RET
MSJ:	LD	B,A
	SRL	B
	SRL	B
	SRL	B
	SRL	B
	INC	B
	LD	E,A
	XOR	A
ZAB:	ADD	10
	DJNZ	ZAB
	SUB	10
	LD	C,A
	LD	HL,MEMHL
	LD	(HL),E
	XOR	A
	RRD
	CP	10
	JR	NC,MSN
	LD	B,A
ZBC:	INC	C
	DJNZ	ZBC
	LD	A,C
	RET
STIME:	LD	A,L
	LD	D,E
	LD	E,C
	CP	24
	JR	C,ST1
	XOR	A
ST1:	PUSH	DE
	CALL	DEHE
	LD	(0001DH),A
	POP	DE
	LD	A,D
	PUSH	DE
	CALL	DEHE
	LD	(0001EH),A
	POP	DE
	LD	A,E
	CALL	DEHE
	LD	(0001FH),A
	RET
DRDEZ:	INC	A
	CP	60
	JR	NZ,DRDW
	LD	A,059H
	JR	DEZ2
DRDW:	LD	H,0
	LD	L,A
	LD	C,0
	LD	DE,10
DEZ1:	INC	C
	SBC	HL,DE
	JR	NC,DEZ1
	ADD	HL,DE
	DEC	C
	SLA	C
	SLA	C
	SLA	C
	SLA	C
	LD	A,C
	OR	L
DEZ2:	CALL	AHEX
	RET
WRITE:	LD	C,1
	CALL	5
	CP	3
	JR	Z,WRE
	CP	01DH
	JR	Z,WCLR
	CP	020H
	JR	C,WSTC
	LD	(HL),A
WRIT2:	LD	E,A
	INC	HL
	CALL	DRUCK
	JR	WRITE
WRE:	LD	(HL),0
	JR	WRE2
WCLR:	LD	DE,(HLM)
	PUSH	HL
	SBC	HL,DE
	POP	HL
	JR	Z,WRITE
	LD	DE,MST01
	CALL	PRNST
	LD	(HL),0
	DEC	HL
	JR	WRITE
WSTC:	LD	(HL),A
	LD	A,0FFH
	JR	WRIT2
WRE2:	PUSH	HL
	LD	HL,(HLM)
	CALL	CRNL
	CALL	HLHEX
	LD	DE,KEYM2
	CALL	PRNST
	POP	HL
	CALL	HLHEX
	JP	CRNL
VCOL:	LD	HL,0E800H
	LD	DE,0E801H
	LD	BC,003C0H
	LD	A,(COL)
	LD	(HL),A
	LDIR
	RET
VERW:	CP	035H
	JP	NC,VMON
	SUB	022H
	LD	HL,VERM
	LD	D,0
	LD	E,A
	ADD	HL,DE
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	PUSH	DE
	EX	AF,AF'
	EXX
	LD	(HLM),HL
	LD	(DEM),DE
	LD	(BCM),BC
	LD	(AME),A
	RET
VERM:	DEFW	SWIT
	DEFW	JUMP
	DEFW	MENU
	DEFW	SAVE
	DEFW	VERIF
	DEFW	LOAD
	DEFW	COLOR
	DEFW	MODIF
	DEFW	DISP
	DEFW	KEY
	DEFW	KEYLI
	DEFW	WRITE
	DEFW	VCOL
	DEFW	RET
	DEFW	AHEX
	DEFW	HLHEX
	DEFW	INLIN
	DEFW	RHEXH
	DEFW	ERR1
RHEXH:	CALL	RHEX
	LD	HL,(MEMHL)
	RET
