;  **********************************
;  ***  BETRIEBSSYSTEM F]R KC 87  ***
;  ***  VERSION 3.0 ,  TEIL 2     ***
;  ***  DIRK AMBRAS , 01.07.1988  ***
;  **********************************
;
CAOS:	EQU	07100H
BSST:	EQU	CAOS-00100H
	ORG	CAOS+00AA4H
ERR1:	EQU	CAOS+00418H
HLHEX:	EQU	CAOS+00462H
PRNST:	EQU	CAOS+00259H
RET:	EQU	CAOS+003A9H
INLIN:	EQU	CAOS+0026EH
DRUCK:	EQU	CAOS+00230H
PRKEY:	EQU	CAOS+007DDH
CRNL:	EQU	CAOS+0097BH
AHEX:	EQU	CAOS+00442H
KEYM1:	EQU	CAOS+007D4H
AME:	EQU	BSST
HLM:	EQU	BSST+00001H
MEMDE:	EQU	BSST+00013H
SCUR:	EQU	BSST+00018H
KEYTA:	EQU	BSST+00021H
EKEY:	EQU	BSST+000F8H
;
SWIT:	CP	2
	JR	Z,SWSE
SWGE:	CP	1
	JR	Z,OKSW
SWERR:	CALL	ERR1
	RET
OKSW:	PUSH	HL
	POP	DE
	PUSH	HL
SWPR:	LD	C,01BH
	CALL	5
	LD	E,2
	CALL	DRUCK
	NOP
	POP	HL
	PUSH	AF
	CALL	HLHEX
	POP	AF
	CP	1
	JR	Z,SWRAM
SWROM:	LD	DE,MROM
SWDR:	CALL	PRNST
	JP	CRNL
MROM:	DEFM	'- ROM'
	DEFB	0
MRAM:	DEFM	'- RAM'
	DEFB	0
SWRAM:	LD	DE,MRAM
	JR	SWDR
SWSE:	LD	A,E
	CP	2
	JR	NC,SWERR
	PUSH	HL
	POP	DE
	PUSH	HL
	LD	C,01CH
	CALL	5
	JR	SWPR
KEY:	LD	A,L
KEY1:	CP	10
	RET	NC
	CALL	SKEY
	LD	DE,EKEY+1
	EX	DE,HL
	AND	A
	SBC	HL,DE
	JP	C,CRNL
	EX	DE,HL
	LD	C,E
	LD	B,D
TASTE:	PUSH	BC
	LD	C,1
	CALL	5
	POP	BC
	AND	A
	JR	Z,TASTE
	CP	3
	JR	NZ,DRKE
KEND:	JP	CRNL
DRKE:	CP	01DH
	JR	Z,CLR
	PUSH	HL
	LD	HL,EKEY
	INC	(HL)
	DEC	(HL)
	POP	HL
	JR	NZ,TASTE
DR1:	LD	HL,EKEY
	LD	D,H
	LD	E,L
	INC	DE
	PUSH	BC
	LDDR
	POP	BC
	INC	HL
	LD	(HL),A
	INC	HL
	LD	E,A
	CP	32
	JR	NC,DR2
	LD	E,0FFH
DR2:	PUSH	BC
	CALL	DRUCK
	POP	BC
	DEC	BC
	JR	TASTE
CLR:	DEC	HL
	LD	A,(HL)
	INC	HL
	AND	A
	JR	Z,TASTE
	DEC	HL
	PUSH	HL
	INC	HL
	INC	BC
	PUSH	BC
	LD	D,H
	LD	E,L
	DEC	DE
	LDIR
	LD	E,01DH
	CALL	DRUCK
	POP	BC
	POP	HL
	JR	TASTE
SKEY:	LD	HL,KEYTA
	LD	B,A
	INC	B
	DEC	HL
	LD	(HL),0
SKEY1:	LD	A,(HL)
	AND	A
	INC	HL
	JR	NZ,SKEY1
	DJNZ	SKEY1
	PUSH	HL
	POP	DE
SKEY2:	CALL	PRKEY
	LD	HL,(MEMDE)
	RET
KAS1:	DEFM	'NAME : '
	DEFB	0
KAS2:	DEFM	'> '
	DEFB	0
KAS3:	DEFM	'? '
	DEFW	7
KAS4:	DEFM	'* '
	DEFW	7
KAS5:	DEFM	'COM'
SAVE:	CP	2
	JP	NC,OKSA
ERRS:	CALL	ERR1
	RET
OKSA:	LD	(0006DH),HL
	LD	(0001BH),HL
	LD	(0006FH),DE
	LD	HL,0FFFFH
	LD	(00071H),HL
	CP	2
	JR	Z,SAV1
	LD	(00071H),BC
	CP	4
	JR	NC,ERRS
SAV1:	LD	DE,KAS1
	CALL	PRNST
	CALL	INLIN
	LD	HL,7
	ADD	HL,DE
	LD	DE,0005CH
	LD	B,8
	CALL	NAMCO
	LD	HL,KAS5
	LD	BC,3
	LDIR
	LD	HL,(0006FH)
	LD	DE,(0006DH)
	SBC	HL,DE
	ADC	HL,HL
	PUSH	HL
	XOR	A
	LD	(00073H),A
	DEC	D
	SBC	H
	PUSH	DE
	XOR	A
	CALL	AHEX
	CALL	0F44AH
	LD	DE,KAS2
	CALL	PRNST
	POP	DE
	POP	BC
	XOR	A
	CP	B
	JR	Z,SAV2
	LD	HL,(HLM)
	LD	(0001BH),HL
	LD	(0006DH),HL
SAV3:	PUSH	BC
	LD	A,(0006BH)
	CALL	AHEX
	CALL	BLRA
	LD	DE,KAS2
	CALL	PRNST
	POP	BC
	DJNZ	SAV3
SAV2:	LD	A,0FFH
	LD	(0006BH),A
	CALL	AHEX
	CALL	BLRA
	LD	DE,KAS2
	CALL	PRNST
	JP	CRNL
BLRA:	LD	BC,160
	LD	DE,(0001BH)
	JP	0F497H
NAMCO:	LD	A,(HL)
	CP	020H
	JR	Z,NCO1
	LD	(DE),A
	INC	HL
	INC	DE
	DJNZ	NAMCO
	RET
NCO1:	LD	A,0
NCO2:	LD	(DE),A
	INC	HL
	INC	DE
	DJNZ	NCO2
	RET
VERIF:	LD	A,0
	JR	LO2
LOAD:	CP	0
	JR	Z,LO1
	CP	1
	JR	Z,LO2
	CALL	ERR1
	RET
LO1:	LD	A,2
LO2:	LD	(MEMDE),A
	LD	A,0
	LD	(AME),A
	POP	HL
	LD	(MEMDE-2),HL
	PUSH	HL
	LD	(MEMDE+3),SP
	LD	(HLM+8),A
	LD	BC,00100H
	LD	HL,00080H
	LD	E,0EFH
	EXX
	LD	HL,00080H
	SCF
	CCF
	CALL	LDM2
	EX	DE,HL
	LD	HL,00080H
	LD	B,8
	PUSH	DE
PNAM:	LD	E,(HL)
	CALL	DRUCK
	INC	HL
	DJNZ	PNAM
	LD	E,32
	CALL	DRUCK
	LD	A,(MEMDE)
	CP	1
	LD	DE,(HLM)
	LD	HL,(00091H)
	JR	NZ,PA1
	PUSH	DE
	POP	HL
PA1:	LD	(HLM),HL
	LD	HL,(00093H)
	JR	NZ,PA2
	PUSH	DE
	LD	DE,(00091H)
	SBC	HL,DE
	LD	DE,(HLM)
	ADD	HL,DE
	POP	DE
PA2:	LD	(HLM+2),HL
	JR	PKC3
PEK3:	LD	A,0FFH
	CP	H
	JR	NZ,PA21
	CP	L
	JR	Z,PA31
PA21:	LD	HL,(00095H)
	PUSH	AF
	LD	A,H
	CP	0FFH
	JR	NZ,PA2E
	LD	A,L
	CP	0FFH
	JR	Z,PA2VE
PA2E:	POP	AF
	LD	DE,(00091H)
	SBC	HL,DE
	LD	DE,(HLM)
	ADD	HL,DE
	JR	PA3
PA2VE:	POP	AF
	JR	PA3
PKC3:	LD	A,(HLM+8)
	CP	1
	JR	NZ,PEK3
PA31:	LD	HL,0FFFFH
PA3:	LD	(HLM+4),HL
	LD	HL,(HLM)
	CALL	HLHEX
	LD	HL,(HLM+2)
	CALL	HLHEX
	LD	HL,(HLM+4)
	CALL	HLHEX
	POP	DE
	CALL	CRNL
	EX	DE,HL
	LD	HL,(HLM)
BLEIN:	SCF
	CALL	LDMA
	CALL	0F310H
	EXX
	INC	B
	EXX
	PUSH	BC
	LD	BC,00080H
	LD	HL,(HLM)
	ADD	HL,BC
	LD	(HLM),HL
	POP	BC
	JR	BLEIN
LDMA:	PUSH	AF
	LD	A,(MEMDE)
	CP	0
	JR	NZ,LDM1
	LD	HL,128
LDM1:	LD	(HLM),HL
	POP	AF
LDM2:	LD	(0001BH),HL
	JR	C,BL1
LDM3:	CALL	0FF59H
BE1:	CALL	0FAE3H
	EX	AF,AF'
	EXX
	LD	A,E
	OR	A
	JR	NZ,BLV
	LD	A,C
	LD	(0006BH),A
BLV:	LD	A,(0006BH)
	CP	0FFH
	JP	Z,BLT
	CP	C
	JR	NZ,FBL
KC31:	INC	C
	EXX
	EX	AF,AF'
	RET
FBL:	CP	1
	JR	NZ,KC1
	INC	C
	CP	C
	JP	Z,KC3
	DEC	C
KC1:	CP	C
	EXX
	LD	HL,(HLM)
BERR:	PUSH	AF
	LD	A,(AME)
	CP	1
	JP	Z,REP1
	LD	A,1
	LD	(AME),A
	LD	E,32
	CALL	DRUCK
	POP	AF
	CALL	AHEX
	LD	DE,KAS3
	CALL	PRNST
	JP	LDMA
BL1:	LD	A,(0006BH)
	PUSH	DE
	PUSH	AF
	LD	A,(EKEY+2)
	LD	E,A
	POP	AF
	CP	E
	JR	Z,B1E
	LD	(EKEY+2),A
	CALL	AHEX
	LD	DE,KAS2
	CALL	PRNST
B1E:	LD	E,8
	CALL	DRUCK
	LD	A,0
	LD	(AME),A
	POP	DE
	LD	HL,LOU1
	DI
	LD	(00202H),HL
	EI
	LD	A,087H
	OUT	(081H),A
	LD	A,2
	OUT	(081H),A
	JP	LDM3
LOU1:	LD	A,0A7H
	OUT	(081H),A
	LD	HL,LOU2
	LD	(00202H),HL
	XOR	A
	OUT	(081H),A
	LD	D,12
	LD	HL,LOU3
	EX	(SP),HL
	EI
	RETI
LOU3:	LD	B,016H
LOU4:	CALL	0FFD1H
	JR	C,LOU3
	CP	090H
	JR	C,LOU3
	DJNZ	LOU4
	LD	A,3
	OUT	(081H),A
	JP	0FF83H
LOU2:	DEC	D
	JR	NZ,LOUE
	LD	A,3
	OUT	(081H),A
	LD	HL,BE1
LOU5:	POP	DE
	CALL	0FCBCH
	JR	NZ,LOU5
	LD	DE,0FAE3H
	PUSH	DE
LOUE:	EI
	RETI
LBL:	CALL	CRNL
	LD	HL,(MEMDE+3)
	LD	SP,HL
	LD	HL,(MEMDE-2)
	EX	(SP),HL
	LD	A,(MEMDE)
	OR	A
	RET	Z
	LD	HL,(HLM+4)
	JP	(HL)
KASKC:	DEFM	'KC85/3'
	DEFM	'-FILE'
	DEFB	0
KC3:	PUSH	DE
	LD	DE,KASKC
	CALL	PRNST
	CALL	CRNL
	POP	DE
	PUSH	AF
	LD	A,1
	LD	(HLM+8),A
	POP	AF
	JP	KC31
REP1:	POP	AF
	PUSH	DE
	CALL	AHEX
	LD	DE,KAS4
	CALL	PRNST
	POP	DE
	JP	LDMA
BLT:	PUSH	AF
	LD	A,(AME)
	CP	1
	JP	Z,REP1
	POP	AF
	LD	E,32
	CALL	DRUCK
	LD	A,0FFH
	CALL	AHEX
	LD	DE,KAS2
	CALL	PRNST
	JP	LBL
BKEY:	LD	DE,KEYM1
	CALL	PRNST
	LD	C,1
	CALL	5
	PUSH	AF
	LD	E,A
	CALL	DRUCK
	CALL	CRNL
	POP	AF
	SUB	030H
	JP	KEY1
